/* SPDX-License-Identifier: GPL-2.0 */
/* Copyright (C) 2023  PaX Team <pageexec@freemail.hu> */

#ifndef _ASM_X86_KERNSEAL_H
#define _ASM_X86_KERNSEAL_H

#include <asm/kernexec.h>

#ifndef __ASSEMBLY__

#ifdef CONFIG_PAX_KERNSEAL
struct page;
void *pax_expose_page(struct page *page) __maybe_used;
void *pax_expose_page_user(struct page *page) __maybe_used;
void *pax_expose_page_nested(struct page *page) __maybe_used;
void *pax_expose_page_nested_user(struct page *page) __maybe_used;
void *pax_expose_page_prot(struct page *page, pgprot_t prot) __maybe_used;
#define __HAVE_ARCH_PAX_EXPOSE_PAGE

void pax_hide_page(const void *address) __maybe_used;
void pax_hide_page_nested(const void *address) __maybe_used;
#define __HAVE_ARCH_PAX_HIDE_PAGE
#endif /* CONFIG_PAX_KERNSEAL */

#include <asm-generic/kernseal.h>

#endif /* __ASSEMBLY__ */

#endif /* _ASM_X86_KERNSEAL_H */
