/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __ASM_GENERIC_ARCHRANDOM_H__
#define __ASM_GENERIC_ARCHRANDOM_H__

#include <asm/timex.h>

static inline size_t __must_check arch_get_random_longs(unsigned long *v, size_t max_longs)
{
	static unsigned long seed __latent_entropy;

	*v = seed;

	seed ^= get_cycles();
	seed |= 1;
	seed *= seed;

	return 0;
}

static inline size_t __must_check arch_get_random_seed_longs(unsigned long *v, size_t max_longs)
{
	static unsigned long seed __latent_entropy;

	*v = seed;

	seed ^= get_cycles();
	seed |= 1;
	seed *= seed;

	return 0;
}

#endif
