/* SPDX-License-Identifier: GPL-2.0 */
/* Copyright (C) 2023  PaX Team <pageexec@freemail.hu> */

#ifndef _ASM_GENERIC_KERNSEAL_H
#define _ASM_GENERIC_KERNSEAL_H

#include <asm-generic/kernexec.h>

#ifndef __ASSEMBLY__

#ifdef CONFIG_PAX_KERNSEAL
#ifndef __HAVE_ARCH_PAX_EXPOSE_PAGE
#error KERNSEAL requires pax_expose_page
#endif

#ifndef __HAVE_ARCH_PAX_HIDE_PAGE
#error KERNSEAL requires pax_hide_page
#endif

static __always_inline __opens(kernel) unsigned long pax_open_seal(void)
{
	return pax_open_kernel();
}

static __always_inline __closes(kernel) unsigned long pax_close_seal(void)
{
	return pax_close_kernel();
}
#else /* !CONFIG_PAX_KERNSEAL */
static __always_inline __opens(kernel) unsigned long pax_open_seal(void)
{
	__open(kernel);
	return 0;
}
static __always_inline __closes(kernel) unsigned long pax_close_seal(void)
{
	__close(kernel);
	return 0;
}
#endif /* CONFIG_PAX_KERNSEAL */

#endif /* __ASSEMBLY__ */

#endif /* _ASM_GENERIC_KERNSEAL_H */
